-- --------------------------------------------------------------------
--   $Id: mult10x6_tb1-a0-ar.vhd,v 1.1 2001/10/05 05:17:06 schaef Exp schaef $
--   Dateiname   : mult10x6_tb1-a0-ar.vhd
--   Titel       : Architecture a0 of mult10x6_tb1
--   Ersteller   : schaef
--   Projekt     : rxpro5
--   Datum       : 04/10/01 14:19:29
--   Bemerkungen : 
--               : 
-- --------------------------------------------------------------------

LIBRARY ieee ;
USE     ieee.std_logic_1164.all ;
USE     ieee.std_logic_arith.all ;
USE     ieee.std_logic_textio.all ;

USE     std.textio.all;

LIBRARY std_developerskit ;
USE     std_developerskit.std_iopak.all ;

LIBRARY rxpro5_rtl;
USE     rxpro5_rtl.ic_typ.all;
LIBRARY rxpro5_hgl;
USE     rxpro5_hgl.ic_tbutil.all;

ARCHITECTURE a0 OF mult10x6_tb1 IS
  CONSTANT VERSION_AR : string := "$Id: mult10x6_tb1-a0-ar.vhd,v 1.1 2001/10/05 05:17:06 schaef Exp schaef $";

   CONSTANT PERIODE : time := 20 ns ;

COMPONENT mult10x6
   PORT(
        Data   : IN  rxpro3_bitvector_t( 9 DOWNTO 0);
        Coef   : IN  rxpro3_bitvector_t( 5 DOWNTO 0);
        Result : OUT             signed(14 DOWNTO 0)
     );
END COMPONENT;

signal inclke     : rxpro3_bit_t := '0';
signal Testreset  : rxpro3_bit_t;

signal Data       : rxpro3_bitvector_t( 9 DOWNTO 0);
signal Coef       : rxpro3_bitvector_t( 5 DOWNTO 0);
signal Result     : rxpro3_bitvector_t(14 DOWNTO 0);
signal Result_sgd :             signed(14 DOWNTO 0);


SIGNAL Simtime              : integer;
                                        
BEGIN

-- Takt
inclke <= not inclke after 0.5 * PERIODE;

dut : mult10x6 
   PORT MAP
      (
        Data        => Data       ,
        Coef        => Coef       ,
        Result      => Result_sgd
       );

Result  <= rxpro3_bitvector_t(Result_sgd);

process
   variable zeile_stim : line;
   VARIABLE zeile_resp : line;
   VARIABLE zeile_out : line;
   VARIABLE simtime_v : integer;
   variable char    : character;
   file stim  : text is in "stim/stimuli.dat";
   file resp  : text is in "stim/response.dat";
   file erg   : text is out "ergebnis.aus";   
   FILE mult_10x6 : text IS OUT "mult10x6.aus";
   variable zeit        : integer;
   variable nachbrenner : natural;
begin
   while (not endfile(stim)) loop -- Kommentar + Parameter lesen
      readline(stim, zeile_stim);
      if (zeile_stim(1) /= '#') then
         exit ;
      end if ;
      read(zeile_stim,char);
      WHILE (char/='=') LOOP 
        read(zeile_stim,char);
        if (zeile_stim'length = 0) then exit; end if ;
      END loop;
      if (zeile_stim'length = 0) then next; end if ;
--      vl_sig_read(zeile_stim, PARAMETER_1);
--      read(zeile_stim,char);
--      WHILE (char/='=') LOOP 
--        read(zeile_stim,char);
--      END loop;
--      vl_sig_read(zeile_stim, PARAMETER_2);
   END loop ;
   wait for 0 fs;
   Testreset <= RSTACT;
   while (not endfile(resp)) loop -- Kommentar in Reponse-File schreiben
     readline(resp, zeile_resp);
     if (zeile_resp(1) /= '#') then
        exit ;
     end if ;
     writeline(mult_10x6, zeile_resp);
   END loop ;
   wait for 0.75 * PERIODE;
   Testreset <= not RSTACT;

   testloop : while (nachbrenner < 2000) loop
      --- Stimuli anlegen ---
    wait until inclke = '0';
    read(zeile_stim,simtime_v);
    Simtime <= simtime_v ;
    vl_sig_read(zeile_stim,Coef);
    vl_sig_read(zeile_stim,Data);    
    IF (not endfile(stim)) THEN
      readline(stim,zeile_stim);
    ELSE
      assert false report "****** STIMULIFILE LEER GELESEN ******" severity error ;
    END if;  
    -- Responses auswerten ---
    wait until inclke = '1';
    fprint(mult_10x6, zeile_out, "%6s %6s\n",to_string(Simtime,"%6d"),
           to_string(conv_integer(signed(Result)),"%6d"));
    if(nachbrenner /= 0) then nachbrenner := nachbrenner + 1; end if;
    -- auswerten
    read(zeile_resp,zeit);
    vl_check_ref_2 (zeile_resp,erg,RESULT, "RESULT", zeit, nachbrenner);
    IF (not endfile(resp)) THEN
      readline(resp,zeile_resp);
    ELSE
      exit ;
    END if;  
   end loop;
   assert false report "****** SIMULATION BEENDET ******" severity failure ;
   wait; -- forever;
end process;

END a0;
